/********************************************************
** Copyright 2002 Earth Resource Mapping Pty Ltd.
** This document contains unpublished source code of
** Earth Resource Mapping Pty Ltd. This notice does
** not indicate any intention to publish the source
** code contained herein.
**
** FILE:     $Archive: /NCS/Source/include/NCSJPCEvent.h $
** CREATED:  05/12/2002 3:27:34 PM
** AUTHOR:   Simon Cope
** PURPOSE:  NCSJPCEvent class
** EDITS:    [xx] ddMmmyy NAME COMMENTS
 *******************************************************/

#ifndef NCSJPCEVENT_H
#define NCSJPCEVENT_H

#ifndef NCSJPCTYPES_H
#include "NCSJPCTypes.h"
#endif // NCSJPCTYPES_H

// Segment class
class NCSJPC_EXPORT_ALL CNCSJPCEvent {
public:
	CNCSJPCEvent(bool bManualReset = false, bool bInitialState = false, char *pLockName = NULL);
	virtual ~CNCSJPCEvent();
	bool Set();
	bool Reset();
	bool Wait(NCSTimeStampMs tsTimeout = -1);

private:
#ifdef WIN32
	HANDLE m_hEvent;
#else
	bool m_bManualReset;
	char *m_pLockName;
	CNCSMutex m_Mutex;
	bool m_bSignalled;
#endif
};

#endif // NCSJPCEVENT_H
